#include "Plotstream.cpp"

template<class T> T round(T v) {return ::floor(v+T(0.5));}
template<class T> T trunc(T v) {return (T)(int)v;}
int remquo(int a, int b, int*c) {
 if (c) *c=a/b;
 return a%b;
}
template<class T> T remquo(T a, T b,int*c) {
 if (c) *c=int(a/b);
 return fmod(a,b);
}

template<class T>struct initializer{
 initializer(const TCHAR*classname);
 static LRESULT CALLBACK PlotWindowProc(HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam);
};

template<class T> LRESULT CALLBACK initializer<T>::PlotWindowProc(HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam) {
 Plotstream<T>*ps=(Plotstream<T>*)GetWindowLongPtr(wnd,0);
 switch (msg) {
  case WM_NCCREATE: {
   CREATESTRUCT*cs=(CREATESTRUCT*)lParam;
   ps=(Plotstream<T>*)cs->lpCreateParams;
   SetWindowLongPtr(wnd,0,(LPARAM)ps);
   ghPlotWnd=wnd;
  }break;
  case WM_PAINT: {
   PAINTSTRUCT s;
   BeginPaint(wnd,&s);
   ps->onPaint(s.hdc);
   EndPaint(wnd,&s);
  }return 0;
  case WM_PRINTCLIENT: {
   ps->onPaint((HDC)wParam);
  }return 0;
  case WM_KEYDOWN: switch (wParam) {
   case VK_ESCAPE: DestroyWindow(wnd); break;
   case VK_SPACE: PostQuitMessage(2); break;
  }break;
  case WM_LBUTTONDOWN: PostQuitMessage(1); break;
  case WM_CLOSE: DestroyWindow(wnd); break;
  case WM_DESTROY: PostQuitMessage(0); break;
  case WM_NCDESTROY: ghPlotWnd=0; break;
 }
 return DefWindowProc(wnd,msg,wParam,lParam);
}

static initializer<double> koolplot_double("koolplot<double>");
static initializer<float> koolplot_float("koolplot<float>");
//static initializer<satint<long>> koolplot_long("koolplot<long>");
//static initializer<satint<short>> koolplot_short("koolplot<short>");

// Verschiedene Konstruktoren fr die verschiedenen Fensterklassen
Plotstream<double>::Plotstream(const char*title) {init("koolplot<double>",title);}
Plotstream<float>::Plotstream(const char*title) {init("koolplot<float>",title);}
//Plotstream<satint<long>>::Plotstream(const char*title):Plotstream("koolplot<long>",title) {}

HWND ghPlotWnd;

template<class T>initializer<T>::initializer(const TCHAR*classname) {
 WNDCLASS wc;
 memset(&wc,0,sizeof wc);
 wc.style=CS_HREDRAW|CS_VREDRAW/*|CS_DBLCLKS*/;
 wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
 wc.hCursor=LoadCursor(0,IDC_ARROW);
 wc.hIcon=LoadIcon(0,IDI_APPLICATION);
 wc.cbWndExtra=sizeof(void*);
 wc.lpfnWndProc=PlotWindowProc;
 wc.lpszClassName=classname;
 RegisterClass(&wc);
}